#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "sa.h"

#define MAX_LINE 1024

/*gcc -I../H -L../lib d33.c random.c sa.c -lRNA -lm -o d33*/
/*gcc -I/home/avihoo/u/ViennaRNA-1.8.4/H -L/home/avihoo/u/ViennaRNA-1.8.4/lib/  d33.c random.c sa.c -lRNA -lm -o new_d33*/

void usage(void);

int main (int argc , char * argv[])
{
   char * ans;
   char * line;
   char * db;
   char * motif;
   char * nucleotide;
   int iteretion_number=100,i;

   db = malloc(sizeof(char)*MAX_LINE);
   line = malloc(sizeof(char)*MAX_LINE);
   motif = malloc(sizeof(char)*MAX_LINE);
   nucleotide = malloc(sizeof(char)*MAX_LINE);

   for (i = 1 ; i < argc ; i++)
   {
	if(argv[i][0] != '-')
		usage();
	switch (argv[i][1])
	{
		case 'i':
			iteretion_number=atoi(argv[++i]);
			break;
		case 't':
			MAX_TRY=atoi(argv[++i]);
			break;
		case 'e':
			tie_ends = 1;
			break;
		case 'm':
			strcpy(motif, argv[++i]);
   			target_motif = motif;
			if (i == argc - 1)
				usage();
			target_motif_location = atoi(argv[++i]);
			break;
		case 'n':
			strcpy(nucleotide, argv[++i]);
   			target_nucleotide = nucleotide;
			if (i == argc - 1)
				usage();
			target_nuc_location = atoi(argv[++i]);
			break;
		case 's':
			allow_slip = 1;
			break;
		case 'h':
		default:
			usage();
			break;
	}
   }
   //printf("Enter structure in dot bracket notation:\n");
   //printf("....,....1....,....2....,....3....,....4....,....5....,....6....,....7....,....8\n");
   fgets(db,MAX_LINE,stdin);
   //target_fold = argv[3];
   db[strlen(db)-1] = '\0';
   if (strlen(db))
   	target_fold = db;
   //printf("Enter the desired minimum free energy in Kcal/mol (do not forget the minus sign)\n");
   fgets(line,MAX_LINE,stdin);
   //target_dG = atof(argv[1]);
   target_dG = atof(line);
   //printf("Enter the desired neutrality\n");
   fgets(line,MAX_LINE,stdin); 
   //target_mr = atof(argv[2]);
   target_mr = atof(line);

   /* Debug print
   printf("db = %s\n",db);
   printf("dG = %f\n",target_dG);
   printf("MR = %f\n",target_mr);
   printf("MAX_TRY = %d\n",MAX_TRY);
   printf("iteration number = %d\n",iteretion_number);
   printf("Tie ends = %s\n",tie_ends?"True":"False");   

   if (target_motif && strlen(target_motif))
	printf("motif = %s, motif len = %zu, motif location = %d\n", target_motif, strlen(target_motif), target_motif_location);

   if (target_nucleotide && strlen(target_nucleotide))
	printf("nucleotide = %s, nucleotide len = %zu, nucleotide location = %d\n",
		target_nucleotide, strlen(target_nucleotide), target_nuc_location);
	*/   
   free(line);
   ans = simulated_anilling(iteretion_number,strlen(db));
   /* Debug print */
   printf("Output sequence (design result) = %s\n",ans);
   printf("%s\n",ans);
   free(ans);
   free(db);
   free(motif);
   free(nucleotide);
   return 0;
}

void usage(void)
{
	printf("application options: RNAextinv [-i num -t num -e -m string num -n string num]\n");
	printf("mandatory input: <target fold (db)> <target dG (Kcal/mol)> <target mutational robastness (0-1)>\n");
	printf("-i num : number of minimization iterations\n");
	printf("-t num : look ahead depth\n");
	printf("-e : try to tie the ends\n");
	printf("-m string num : add motif constraint\n");
	printf("-n string num : add nucleotide constraint\n");
	printf("-s : allow a single-nucleotide slippage\n");
	exit(1);
}
    
