/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import javax.swing.*;
import java.text.MessageFormat;
import java.util.Collections;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

public class FragmentParser implements java.awt.event.ActionListener
{
    private String shapiro;
    java.util.TreeMap<Integer, MotifData> motifs;
    MotifData selectedMotif;
    
    public FragmentParser(String shapiro)
    {
	this.selectedMotif = null;
        this.shapiro = shapiro;
        this.motifs = new java.util.TreeMap<Integer, MotifData>(Collections.reverseOrder());

        java.util.regex.Pattern pattern = java.util.regex.Pattern.compile("\\(\\(H[0-9]+\\)S[0-9]+\\)");
        
        java.util.regex.Matcher matcher = pattern.matcher(shapiro);
        while (matcher.find()) {
            motifs.put(new Integer(matcher.start()), new MotifData("Stem-loop", matcher.group(), matcher.start(), matcher.end()));
        }

        pattern = java.util.regex.Pattern.compile("E[0-9]+|R|I[0-9]+|M[0-9]+");
        matcher = pattern.matcher(shapiro);
        while (matcher.find()) {
            if (matcher.group().matches("E[0-9]+"))
                motifs.put(new Integer(matcher.start()), new MotifData("External", matcher.group(), matcher.start(), matcher.end()));
            if (matcher.group().matches("R"))
                motifs.put(new Integer(matcher.start()), new MotifData("5'-3'", matcher.group(), matcher.start(), matcher.end()));
            if (matcher.group().matches("M[0-9]+"))
                motifs.put(new Integer(matcher.start()), new MotifData("Multi-loop", matcher.group(), matcher.start(), matcher.end()));
            if (matcher.group().matches("I[0-9]+"))
                motifs.put(new Integer(matcher.start()), new MotifData("Internal-loop", matcher.group(), matcher.start(), matcher.end()));
        }

        pattern = java.util.regex.Pattern.compile("S[0-9]+");
        matcher = pattern.matcher(shapiro);
        while (matcher.find()) {
            Map.Entry entry = motifs.higherEntry(new Integer(matcher.start()));
            if (entry != null)
            {
                MotifData motif = (MotifData)entry.getValue();
                if (motif.getEndIndex() > matcher.start()) {
                    continue;
                }
            }

            motifs.put(new Integer(matcher.start()), new MotifData("Stem", matcher.group(), matcher.start(), matcher.end()));
        }
    }

    public java.util.TreeMap<Integer, MotifData> getMotifs()
    {
        return this.motifs;
    }

    public void printMotifs()
    {
	for (Map.Entry<Integer, MotifData> entry : this.motifs.entrySet()) {
     		System.out.println("Key: " + entry.getKey() + ". Value: " + entry.getValue().toFullString());
	}
    }
    
    public MotifData getSelectedMotif()
    {
        return selectedMotif;
    }

    public void actionPerformed(java.awt.event.ActionEvent evt)
    {
            JComboBox cb = (JComboBox)evt.getSource();
            this.selectedMotif = (MotifData)cb.getSelectedItem();
            // System.out.println(MessageFormat.format("Selected element = {0}", this.selectedMotif));
    }
}
