import java.text.MessageFormat;
import static java.lang.String.valueOf;

public class NucData
{
    private String nucSequence;
    private int nucStartLocation;
    private boolean isSlippageAllowed;

    public NucData(String seq, String location, boolean isSlipAllowed)
    {
	nucSequence = seq;
	nucStartLocation = Integer.parseInt(location) - 1; // User counts location from 1 not 0
	isSlippageAllowed = isSlipAllowed;
    }

    public boolean isSlippageAllowed()
    {
	return isSlippageAllowed;
    }

    public String getNucSequence()
    {
	return nucSequence;
    }

    public int getNucStartLocation()
    {
	return nucStartLocation;
    }

    public String toString()
    {
       	return MessageFormat.format("nucleotide sequence {0}\nnucleotide location {1}\nallow slippage: {2}\n",
       	        this.nucSequence, this.nucStartLocation, this.isSlippageAllowed);
    }
}
 
