/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
*/


import java.awt.*;
import javax.swing.*;
import java.text.MessageFormat;
import java.util.*;
import java.io.*;
import javax.swing.JFrame;


/**
 *
 * @author Hofit Elimelech and Mor Shahak
 *
 */
public class ProcessFrame extends JFrame implements SwingConstants{
    private final javax.swing.JButton startButton = new javax.swing.JButton();
    private final javax.swing.JButton resetButton = new javax.swing.JButton();
    private final javax.swing.JButton resultButton = new javax.swing.JButton();
    private final javax.swing.JButton headButton = new javax.swing.JButton();
    private final javax.swing.JLabel headLabel = new javax.swing.JLabel("Please insert your structure (Dot Bracket)");
    private final javax.swing.JTextArea inputTextArea = new javax.swing.JTextArea();;
    private final javax.swing.JScrollPane inputScrollPane = new javax.swing.JScrollPane();
    private final JTextField lookaheadb = new JTextField(  );
    private final JTextField minIt = new JTextField(  );
    private final JTextField dDg = new JTextField(  );
    private final JTextField dN = new JTextField(  );
    private final JTextField nuc = new JTextField(  );
    private final JTextField nucLocation = new JTextField(  );
    private final JCheckBox noMr = new JCheckBox("Disregard mutational robustness constraint");
    private final JCheckBox noDg = new JCheckBox("Disregard minimal free energy constraint");
    private final JCheckBox slip = new JCheckBox("Allow single-nucleotide slippage");
    private final JTextField tiEnds = new JTextField(  );
    private Data dat = null;
    private MotifData motif;
    private ResultFrame res;
    private int resetCounter;
    /**
     * @param args the command line arguments
     */

    public void init(String db, MotifData inputMotif) {
        this.dat = new Data();
        resetCounter = 0;
        initComponents();
        inputTextArea.setFont(new java.awt.Font("Monospaced",java.awt.Font.PLAIN, 14));
        if (db != null)
        {
            inputTextArea.setText(db);
            inputTextArea.setEnabled(false);
        }

        if (inputMotif != null && inputMotif.getName() != "5'-3'")
            this.motif = inputMotif;

    }

    private void initComponents() {

        java.awt.GridBagConstraints gridBagConstraints;
        getContentPane().setLayout(new java.awt.GridBagLayout());

	JPanel jp = new JPanel();
	jp.setPreferredSize(new Dimension(500,600));
	getContentPane().add( jp );
	pack();

        /* setting the text in the buttons */
        startButton.setText("Start  ");
        resetButton.setText("Reset ");
        resultButton.setText("Result");
        headButton.setText("Please insert your structure (Dot Bracket)");
        headLabel.setFont(new java.awt.Font("Times New Roman",java.awt.Font.BOLD, 14));

        startButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startAction(evt);
            }
        });

        resultButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resultAction(evt);
            }
        });
        resetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resetAction(evt);
            }
        });

        /* defining the input area */
        inputTextArea.setColumns(20);
        inputTextArea.setMargin(new java.awt.Insets(4, 4, 4, 4));
        inputScrollPane.setViewportView(inputTextArea);

        /*defining the panel constraints */

        /*head button*/
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 8;
        gridBagConstraints.ipadx = 25;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 12);
        getContentPane().add(headLabel, gridBagConstraints);

        /*head button*/
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridheight = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(4, 6, 12, 6);
        getContentPane().add(inputScrollPane, gridBagConstraints);

        /* start button */
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.ipadx = 25;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 12);
        getContentPane().add(startButton, gridBagConstraints);

        /* reset button*/
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.ipadx = 25;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 12);
        getContentPane().add(resetButton, gridBagConstraints);


        /* result button*/
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.ipadx = 25;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 12);
        getContentPane().add(resultButton, gridBagConstraints);


        /*defining lower panel*/
        JPanel lookahead = new JPanel(  );
        lookahead.add( new JLabel( "Look Ahead Depth:" ) );
        lookaheadb.setColumns( 2 );
        lookaheadb.setText( "0" );
        lookaheadb.setMargin(new java.awt.Insets(2, 2, 2, 4));
        lookaheadb.setFont(new java.awt.Font("Times New Roman",java.awt.Font.PLAIN, 14));
        lookahead.add( lookaheadb );

        JPanel minimization = new JPanel(  );
        minimization.add( new JLabel( "Num. of Minimization Iterations:" ) );
        minIt.setColumns( 3 );
        minIt.setText( "100" );
        minIt.setMargin(new java.awt.Insets(2, 2, 2, 4));
        minIt.setFont(new java.awt.Font("Times New Roman",java.awt.Font.PLAIN, 14));
        minimization.add( minIt );

        JPanel dg = new JPanel(  );
        dg.add( new JLabel( "Desired free energy (kcal/mol): " ) );
        dDg.setColumns( 4 );
        dDg.setText( "0" );
        dDg.setMargin(new java.awt.Insets(2, 2, 2, 4));
        dDg.setFont(new java.awt.Font("Times New Roman",java.awt.Font.PLAIN, 14));
        dg.add( dDg );

        JPanel neutrality = new JPanel(  );
        neutrality.add( new JLabel( "Desired neutrality:" ) );
        dN.setColumns( 4 );
        dN.setText( "0" );
        dN.setMargin(new java.awt.Insets(2, 2, 2, 4));
        dN.setFont(new java.awt.Font("Times New Roman",java.awt.Font.PLAIN, 14));
        neutrality.add( dN );

        JPanel tiends = new JPanel(  );
        tiends.add( new JLabel( "Tie Ends (1 or 0): " ) );
        tiEnds.setColumns( 2 );
        tiEnds.setText( "0" );
        tiEnds.setMargin(new java.awt.Insets(2, 2, 2, 4));
        tiEnds.setFont(new java.awt.Font("Times New Roman",java.awt.Font.PLAIN, 14));
        tiends.add( tiEnds );

        JPanel arguments = new JPanel(  );
        arguments.setLayout( new GridLayout( 0, 1 ) );
        arguments.setBorder( BorderFactory.createCompoundBorder(
                BorderFactory.createTitledBorder( "Physical Parameters" ),
                BorderFactory.createEmptyBorder( 5, 5, 5, 5 ) ) );
        arguments.setPreferredSize( new Dimension( 310, 140 ) );

	noMr.setHorizontalTextPosition(SwingConstants.RIGHT);
	noMr.setSelected(false);

	noDg.setHorizontalTextPosition(SwingConstants.RIGHT);
	noDg.setSelected(false);

        arguments.add( dg );
        arguments.add( noDg );
        arguments.add( neutrality );
        arguments.add( noMr );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 8;
        gridBagConstraints.ipadx = 60;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(arguments, gridBagConstraints);

        JPanel nucleotide = new JPanel(  );
        nucleotide.add( new JLabel( "Desired nucleotide(s):" ) );
        nuc.setColumns( 4 );
        nuc.setText( "" );
        nuc.setMargin(new java.awt.Insets(2, 2, 2, 4));
        nuc.setFont(new java.awt.Font("Times New Roman",java.awt.Font.PLAIN, 14));
        nucleotide.add( nuc );

        JPanel nucleotideLocation = new JPanel(  );
        nucleotideLocation.add( new JLabel( "Desired nucleotide(s) start location:" ) );
        nucLocation.setColumns( 4 );
        nucLocation.setText( "0" );
        nucLocation.setMargin(new java.awt.Insets(2, 2, 2, 4));
        nucLocation.setFont(new java.awt.Font("Times New Roman",java.awt.Font.PLAIN, 14));
        nucleotideLocation.add( nucLocation );

	    slip.setHorizontalTextPosition(SwingConstants.RIGHT);
        slip.setSelected(false);

		JPanel nucArguments = new JPanel(  );
		nucArguments.setLayout( new GridLayout( 0, 1 ) );
		nucArguments.setBorder( BorderFactory.createCompoundBorder(
		BorderFactory.createTitledBorder( "Nucleotide Constraints" ),
		BorderFactory.createEmptyBorder( 5, 5, 5, 5 ) ) );
		nucArguments.setPreferredSize( new Dimension( 310, 140 ) );

        nucArguments.add( nucleotide );
        nucArguments.add( nucleotideLocation );
        nucArguments.add( slip );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 20;
        gridBagConstraints.gridwidth = 8;
        gridBagConstraints.ipadx = 60;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(nucArguments, gridBagConstraints);
    }

    private void resetAction (java.awt.event.ActionEvent event){
        resetCounter++;
        inputTextArea.setText("");
        inputTextArea.setEnabled(true);
        lookaheadb.setText("0");//box for Clustering Resolution
        minIt.setText("100");
        dDg.setText("0");
        dN.setText("0");
        tiEnds.setText("0");
        nuc.setText( "" );
        nucLocation.setText( "0" );
        slip.setSelected(false);
        noMr.setSelected(false);
        noDg.setSelected(false);

        this.res = new ResultFrame(this.dat, resetCounter);
        this.motif = null;

        System.gc();
    }

    private void resultAction (java.awt.event.ActionEvent event){
        this.res = new ResultFrame(this.dat , resetCounter);
        res.init();
    }

    private void startAction (java.awt.event.ActionEvent event){
	boolean isLegalInput = true;
        resetCounter++;
        this.dat = new Data();

        File file = new File("tmp" + File.separator + "input.txt");
        FileWriter fw = null;

        try
        {
            fw = new FileWriter(file);

            String dotBrack = (inputTextArea.getText()).trim();
            this.dat.setRecDB(dotBrack);
            String lahead = (lookaheadb.getText()).trim();
            String minit = (minIt.getText()).trim();

            String ddg = noDg.isSelected() ? "-1000.0" : (dDg.getText()).trim();
            String dn =  noMr.isSelected() ? "-1000.0" : (dN.getText()).trim();
            this.dat.setDesiredNeut(Double.parseDouble(dn));
            this.dat.setTargetDG(Double.parseDouble(ddg));

            String tends = (tiEnds.getText()).trim();

            fw.write(dotBrack +"\n"+ ddg.trim() + "\n" + dn.trim() + "\n" +tends.trim()+ "\n" + minit.trim() +"\n" + lahead.trim());
        }
        catch(java.io.IOException e){
            System.out.println("IOEXCEPTION IN Writing to FILE: " + e.getMessage());
        }
        finally{
            try{
                if( fw!=null ){
                    fw.close();
                }
            }
            catch(java.io.IOException e){
                System.out.println("IOEXCEPTION IN Writing to FILE: " + e.getMessage());
            }
        }

	try 
        {
		String nucSequence = (nuc.getText()).trim();
		if (!nucSequence.isEmpty())
		{
		   String location = (nucLocation.getText()).trim();
		   if (location.isEmpty())
			throw new InvalidNucleotideInputException("Empty input string");
		   NucData nucData = new NucData(nucSequence, location, slip.isSelected());
		   this.dat.setNucData(nucData);
		}
	}
        catch (Exception e)
        {
            System.out.println(e);
	    isLegalInput = false;
        }

        if (!isLegalInput || !isBalanced(this.dat.getRecDB()))
        {
            ErrorFrame err = new ErrorFrame();
            err.init();
	    return;	
        }

	try 
        {
	Utils.createWildTypePlot(this.dat.getRecDB());
	RNAshapiroParser parser = new RNAshapiroParser();
	this.dat.setShapiro(parser.GetShapiro(this.dat.getRecDB()));

	String os = System.getProperty("os.name");
	String programName;
	if (!os.startsWith("Windows"))	
		programName = "bin" + File.separator + "RNAexinv";
	else
		programName = "bin" + File.separator + "RNAexinv.exe";
	java.util.List<String> commandAndOptions_ProcessBuilder = new ArrayList<String>();
	commandAndOptions_ProcessBuilder.add(programName);
	if (this.motif != null) 
	{
		commandAndOptions_ProcessBuilder.add("-m");
		commandAndOptions_ProcessBuilder.add(motif.getValue());
		commandAndOptions_ProcessBuilder.add(Integer.toString(motif.getStartIndex()));
	}	

	if (this.dat.getNucData() != null)
	{
		commandAndOptions_ProcessBuilder.add("-n");
		commandAndOptions_ProcessBuilder.add(this.dat.getNucData().getNucSequence());
		commandAndOptions_ProcessBuilder.add(Integer.toString(this.dat.getNucData().getNucStartLocation()));
		if (this.dat.getNucData().isSlippageAllowed())
			commandAndOptions_ProcessBuilder.add("-s");
	}
	// Iterator<String> iterator = commandAndOptions_ProcessBuilder.iterator();
	// while (iterator.hasNext()) {
		// System.out.println(iterator.next());
	//}

	for (int i = 0; i < Data.NUM_RESULTS; i++)
	{
		System.out.print(i+1+"...");
		final Ans newAns = new Ans();
		final String db = this.dat.getRecDB();
		ProcessBuilder pb = new ProcessBuilder(commandAndOptions_ProcessBuilder);
		Process process = pb.start();		

		final OutputStream pos = process.getOutputStream();
		final PrintWriter pw = new PrintWriter(pos);
		final InputStream fis = new FileInputStream("tmp" + File.separator + "input.txt");
		final BufferedReader fileBr = new BufferedReader(new InputStreamReader(fis));

		Thread t1 = new Thread(new Runnable() {
		public void run() {
			try {
				String lineRead;
				while ((lineRead = fileBr.readLine()) != null) {
					pw.print(lineRead + "\n");
				}
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				if (pw != null)
					pw.close();
				if (fileBr != null) {
					try {
						fileBr.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}
		}
		});
		t1.start();

		final InputStream pes = process.getErrorStream();
		Thread t3 = new Thread(new Runnable() {
		public void run() {
			DataInputStream p_err = new DataInputStream(pes);
			Scanner scan = new Scanner(p_err);
			while(scan.hasNextLine())
				System.out.print(scan.nextLine());
			scan.close();

			try {
				pes.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		});
		t3.start();

		final InputStream is = process.getInputStream();
		// the background thread watches the output from the process
		Thread t2 = new Thread(new Runnable() {
		public void run() {
			Scanner scan = new Scanner(new DataInputStream(is));

			while(scan.hasNextLine())
			{
			   if (scan.findInLine("design result") != null){
			       scan.next();
			       scan.next();
			       newAns.seq = scan.next();
				// System.out.println(newAns.seq);
			   }

			   else if (scan.findInLine("Output mutational robustness =") != null){
			       newAns.neut = scan.next();
				// System.out.println(newAns.neut);
			   }
			   else if (scan.findInLine("Output minimum free energy") != null){
			       scan.next();
			       scan.next();
			       newAns.dg = scan.next();
				// System.out.println(newAns.dg);
			   }
			   else if (scan.findInLine("Output shape in Shapiro representation =") != null){
			       newAns.shapiro = scan.next();
				// System.out.println(newAns.shapiro);
			   }
			   scan.nextLine();
			}
			scan.close();
			try {
				is.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		});
		t2.start();

		int exitVal = process.waitFor();
		t2.join();
		t3.join();
		if (exitVal != 0)
		{
			continue;
		}
		newAns.dot = Utils.createRnaFold(newAns);                
		newAns.dist = Utils.calculateRnaDistance(newAns, db);
		dat.addToAnsVec(newAns);
		
	} // End of while
	} // End of try
	catch (Exception e)
	{
		System.err.println("StartAction Error: ");
		e.printStackTrace();
	}
    }

    private boolean isBalanced (String brack){
        int left = 0; int right= 0;

        if(brack.length()<1){
            return false;
        }
        for (int i = 0; i < brack.length(); i++) {
            if  (brack.charAt(i) == '('){
                left++;
            }
            else if (brack.charAt(i) == ')') {
                right++;
            }
            else if (brack.charAt(i) != '.'){
                return false;
            }
            if (right > left){
                return false;
            }
            if (i == (brack.length()-1)){
                return (left == right);
            }
        }
        return true;
    }
}
